package com.knauf.ejb.nm;
import com.knauf.ejb.nm.BuchstabeLocal;
import java.util.ArrayList;
/**
 * Local interface for Enterprise Bean: Wort
 */
public interface WortLocal extends javax.ejb.EJBLocalObject {
	/**
	 * Get accessor for persistent attribute: wort
	 */
	public java.lang.String getWort();
	/**
	 * Set accessor for persistent attribute: wort
	 */
	public void setWort(java.lang.String newWort);
	/**
	 * This method was generated for supporting the relationship role named buchstaben.
	 * It will be deleted/edited when the relationship is deleted/edited.
	 */
	public java.util.Collection getBuchstaben();
	/**
	 * This method was generated for supporting the relationship role named buchstaben.
	 * It will be deleted/edited when the relationship is deleted/edited.
	 */
	public void setBuchstaben(java.util.Collection aBuchstaben);
	/**Hinzufgen eines Buchstaben zu den Buchstaben dieses Worts (die einzige Business-Methode).
	 * @param buchstabe Der zuzufgende Buchstabe.
	 * Wenn er bereits vorkommt, geschieht nichts (Wort enthlt einen Buchstabe doppelt).
	 */
	public void addBuchstabe(BuchstabeLocal buchstabe);
	/**Entfernen eines Buchstabens aus den Buchstaben dieses Worts.
	 * @param buchstabe Der zu entfernende Buchstabe. Falls er nicht vorhanden ist,
	 * wird eine EJB-Exception ausgelst.
	 */
	public void removeBuchstabe(BuchstabeLocal buchstabe);
	/**Abrufen der Buchstabenliste.
	 * NUR hierber darf ein Client an die Buchstaben kommen. "getBuchstaben" ist nur fr den Container ?
	 * @return Eine Liste aller Buchstaben.
	 */
	public ArrayList getBuchstabenListe();
}
