<%@page contentType="text/html; charset=windows-1252" %>
<%@ page import="javax.naming.InitialContext"%>
<%@ page import="java.util.ArrayList"%>
<%@ page import="java.util.Iterator"%>
<%@ page import="javax.ejb.FinderException"%>
<%@ page import="com.knauf.ejb.nm.*"%>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<HTML>
<HEAD>
  <TITLE>Wort bearbeiten</TITLE>
  <meta http-equiv="content-type" content="text/html; charset=Windows-1252">
</HEAD>
<BODY>
<H1>Wort bearbeiten</H1> <br>
<h3>Vorhandene Worte: </h3>
<%
  //Fllen der ListBox
  InitialContext initialContext = new InitialContext();
  Object homeref = initialContext.lookup ("java:comp/env/ejb/Wort");
  WortLocalHome wortHome = (WortLocalHome) homeref;
  BuchstabeLocalHome buchstabeHome = (BuchstabeLocalHome) initialContext.lookup ("java:comp/env/ejb/Buchstabe");

  //Verzweigen je nach Typ der Anfrage:
  String strSubmitType = request.getParameter("submit");
  if ("Neu".equals (strSubmitType) == true)
  {
    //Formular fr neues Wort ausgeben:
%>
  <FORM method="post">
    Wort: <input type="text" name="wort"> <br>
    <INPUT TYPE="SUBMIT" NAME="submit" VALUE="NeuOK">
  </FORM>
<%
  }
  else if ("NeuOK".equals (strSubmitType) == true)
  {
    //Nach dem "Neu"-Formular: Wort erzeugen.
    String strWort = request.getParameter("wort");
    WortLocal wortNeu = wortHome.createByWort(strWort );

    //Auerdem die Verknpfung "Buchstaben<->Worte" erzeugen. 
    //Dazu fr jedes Zeichen prfen, ob es schon die zugehrige Buchstabe-Bean gibt.
    //Wenn nein, dann wird sie angelegt. Diese Buchstabe-Bean wird der Collection
    //der Buchstaben des Worts zugefgt.
    //ber den String laufen:
    for (int intIndexBuchstabe = 0; intIndexBuchstabe < strWort.length(); intIndexBuchstabe++)
    {
      String strBuchstabeAktuell = strWort.substring(intIndexBuchstabe, intIndexBuchstabe + 1);
      
      //Den Buchstaben laden bzw. neu erzeugen, falls noch nicht vorhanden.
      BuchstabeLocal buchstabeAktuell = null;
      try
      {
        buchstabeAktuell = buchstabeHome.findByBuchstabe(strBuchstabeAktuell);
      }
      catch (FinderException fex)
      {
        //Buchstabe ist noch nicht vorhanden -> Erzeugen !
        buchstabeAktuell = buchstabeHome.createByBuchstabe(strBuchstabeAktuell);
      }
      
      //Zufgen zur Collection (checkt selbstndig nach Duplikaten und schliet diese aus).
      wortNeu.addBuchstabe(buchstabeAktuell); 
    }
    
    //Request weiterleiten an bersichtsseite:
    request.getRequestDispatcher ("index.jsp").forward(request, response);
  }
  else if ("Bearbeiten".equals(strSubmitType) == true)
  {
    //Wort bearbeiten: Das Wort holen (ID steckt im Request !) und das Wort ins Textfeld schreiben.
    //Die ID allerdings in Integer umwandeln, denn der Request sendet einen String !
    String strID = request.getParameter("wortid");
    WortLocal wortBearbeiten = wortHome.findByPrimaryKey( Integer.valueOf(strID) );
  %>
  <FORM method="post">
    Wort: <input type="text" name="wort" value="<%=wortBearbeiten.getWort()%>"/> <br/>
    Besteht aus diesen Buchstaben: <br/>
    <ul> <%
    //Liste der Buchstaben ausgeben:
    ArrayList listBuchstaben = wortBearbeiten.getBuchstabenListe();
    Iterator iteratorBuchstaben = listBuchstaben.iterator();
    while (iteratorBuchstaben.hasNext() == true)
    {
      BuchstabeLocal buchstabe = (BuchstabeLocal) iteratorBuchstaben.next();
%>     <li><%=buchstabe.getBuchstabe()%></li>
<%
    }
%>    </ul><br> <br>
    <INPUT TYPE="SUBMIT" NAME="submit" VALUE="BearbeitenOK"> <br>
    <!--Die Wort-ID als Hidden Field mitfhren -->
    <input type="hidden" name="wortid" value="<%=wortBearbeiten.getPrimaryKey()%>">
  </FORM>
<%
  }
  else if ("BearbeitenOK".equals(strSubmitType) == true)
  {
    //Im Bearbeiten-Formular auf "OK" geklickt: Kuchen updaten.
    //Das Wort holen (ID steckt im Request).
    //Die ID allerdings in Integer umwandeln, denn der Request sendet einen String !
    String strID =  request.getParameter("wortid");
    WortLocal wortBearbeiten = wortHome.findByPrimaryKey( Integer.valueOf(strID) );

    String strWort = request.getParameter("wort");
    wortBearbeiten.setWort( strWort);

    //Auerdem die Verknpfung "Buchstaben<->Worte" erzeugen. 
    //Teil 1: Neu hinzugekommene Buchstaben verarbeiten.
    //Dazu fr jedes Zeichen prfen, ob es schon die zugehrige Buchstabe-Bean gibt.
    //Wenn nein, dann wird sie angelegt. Diese Buchstabe-Bean wird der Collection
    //der Buchstaben des Worts zugefgt.
    //ber den String laufen:
    for (int intIndexBuchstabe = 0; intIndexBuchstabe < strWort.length(); intIndexBuchstabe++)
    {
      String strBuchstabeAktuell = strWort.substring(intIndexBuchstabe, intIndexBuchstabe + 1);
      
      //Den Buchstaben laden bzw. neu erzeugen, falls noch nicht vorhanden.
      BuchstabeLocal buchstabeAktuell = null;
      try
      {
        buchstabeAktuell = buchstabeHome.findByBuchstabe(strBuchstabeAktuell);
      }
      catch (FinderException fex)
      {
        //Buchstabe ist noch nicht vorhanden -> Erzeugen !
        buchstabeAktuell = buchstabeHome.createByBuchstabe(strBuchstabeAktuell);
      }
      
      //Zufgen zur Collection (checkt selbstndig nach Duplikaten und schliet diese aus).
      wortBearbeiten.addBuchstabe(buchstabeAktuell); 
    }
    
    //Teil 2: Entfernen nicht mehr enthaltener Buchstabenzuordnungen (nicht der Buchstaben selbst).
    ArrayList listBuchstaben = wortBearbeiten.getBuchstabenListe();
    for (int intIndexBuchstabe = 0; intIndexBuchstabe < listBuchstaben.size(); intIndexBuchstabe++)
    {
      BuchstabeLocal buchstabeAktuell = (BuchstabeLocal) listBuchstaben.get(intIndexBuchstabe);
      if (strWort.indexOf(buchstabeAktuell.getBuchstabe() ) == -1)
      {
      	//Weg damit....
      	wortBearbeiten.removeBuchstabe(buchstabeAktuell);
      }
    }
    
    //Request weiterleiten an bersichtsseite:
    request.getRequestDispatcher ("index.jsp").forward(request, response);
  }
  else if ("Loeschen".equals(strSubmitType) == true)
  {
    //Wort lschen:
    //Die ID allerdings in Integer umwandeln, denn der Request sendet einen String !
    String strID =  request.getParameter("wortid");
    WortLocal wortBearbeiten = wortHome.findByPrimaryKey( Integer.valueOf(strID) );
    wortBearbeiten.remove();

    //Request weiterleiten an bersichtsseite:
    request.getRequestDispatcher ("index.jsp").forward(request, response);
  }
%>
</body>

</html>
