package com.knauf.ejb.nm;
import com.knauf.ejb.nm.WortLocal;
import java.util.ArrayList;
/**
 * Local interface for Enterprise Bean: Buchstabe
 */
public interface BuchstabeLocal extends javax.ejb.EJBLocalObject {
	/**
	 * Get accessor for persistent attribute: buchstabe
	 */
	public java.lang.String getBuchstabe();
	/**
	 * Set accessor for persistent attribute: buchstabe
	 */
	public void setBuchstabe(java.lang.String newBuchstabe);
	/**
	 * This method was generated for supporting the relationship role named worte.
	 * It will be deleted/edited when the relationship is deleted/edited.
	 */
	public java.util.Collection getWorte();
	/**
	 * This method was generated for supporting the relationship role named worte.
	 * It will be deleted/edited when the relationship is deleted/edited.
	 */
	public void setWorte(java.util.Collection aWorte);
	/**Hinzufgen eines Worts zu den Worten dieses Buchstabens (die einzige Business-Methode).
	 * @param wort Das zuzufgende Wort.
	 * Wenn es bereits vorkommt, geschieht nichts.
	 */
	public void addWort(WortLocal wort);
	/**Abrufen der Wortliste.
	 * NUR hierber darf ein Client an die Worte kommen. "getWorte" ist nur fr den Container ?
	 * @return Eine Liste aller Worte.
	 */
	public ArrayList getWortListe();
}
