package com.knauf.ejb.nm;
/**
 * Local Home interface for Enterprise Bean: Buchstabe
 */
public interface BuchstabeLocalHome extends javax.ejb.EJBLocalHome {
	/**
	 * Creates an instance from a key for Entity Bean: Buchstabe
	 */
	public com.knauf.ejb.nm.BuchstabeLocal create()
		throws javax.ejb.CreateException;
	/**
	 * Finds an instance using a key for Entity Bean: Buchstabe
	 */
	public com.knauf.ejb.nm.BuchstabeLocal findByPrimaryKey(
		java.lang.Integer primaryKey)
		throws javax.ejb.FinderException;
	public java.util.Collection findAll() throws javax.ejb.FinderException;
	public com.knauf.ejb.nm.BuchstabeLocal findByMaxId() throws javax.ejb.FinderException;
	/**Erzeugen eines Buchstabe-Objekts, wobei der Buchstabe angegeben wird. Der Key wird automatisch erzeugt.
	 * @param str_Buchstabe Der Buchstabe. Sollte Unique sein.
	 * @return Den Primary Key, hier die ID.
	 * @exception CreateException Fehler beim Erzeugen.
	 */
	public com.knauf.ejb.nm.BuchstabeLocal createByBuchstabe(
		String str_Buchstabe)
		throws javax.ejb.CreateException;
	/**
	 * Creates an instance from a key for Entity Bean: Buchstabe
	 */
	public com.knauf.ejb.nm.BuchstabeLocal create(java.lang.Integer id)
		throws javax.ejb.CreateException;
	public com.knauf.ejb.nm.BuchstabeLocal findByBuchstabe(
		java.lang.String buchstabe)
		throws javax.ejb.FinderException;
}
