package com.knauf.ejb.nm;
/**
 * Local Home interface for Enterprise Bean: Wort
 */
public interface WortLocalHome extends javax.ejb.EJBLocalHome {
	/**
	 * Creates an instance from a key for Entity Bean: Wort
	 */
	public com.knauf.ejb.nm.WortLocal create()
		throws javax.ejb.CreateException;
	/**
	 * Finds an instance using a key for Entity Bean: Wort
	 */
	public com.knauf.ejb.nm.WortLocal findByPrimaryKey(
		java.lang.Integer primaryKey)
		throws javax.ejb.FinderException;
	public java.util.Collection findAll() throws javax.ejb.FinderException;
	public com.knauf.ejb.nm.WortLocal findByMaxId() throws javax.ejb.FinderException;
	/**Erzeugen eines Wort-Objekts, wobei das Wort angegeben wird. Der Key wird automatisch erzeugt.
	 * @param str_Wort Das Wort. Sollte Unique sein.
	 * @return Immer NULL, da der Primary Key vom Container verwaltet wird.
	 * @exception CreateException Fehler beim Erzeugen.
	 */
	public com.knauf.ejb.nm.WortLocal createByWort(String str_Wort)
		throws javax.ejb.CreateException;
	/**
	 * Creates an instance from a key for Entity Bean: Wort
	 */
	public com.knauf.ejb.nm.WortLocal create(java.lang.Integer id)
		throws javax.ejb.CreateException;
}
